#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <cuda.h>
#include <math.h>
#include "Chi8.h"

__global__ void kernel( unsigned int rows, unsigned int cols , int cRows , int contRows ,int jobs,int ref, unsigned char *snpdata,float *results,int *dev_colid){
        unsigned char x, y;
        int m, n ;
	unsigned int p = 0 ;
        int cases[9];
	int controls[9];
	int tot_cases = 1;
        int tot_controls= 1;
        int total = 1;
        float chisquare = 0.0f;
        float exp[10];        
	float Conexpected[9];        
	float Cexpected[9];
	float numerator1;
	float numerator2;
	

        int tid  = threadIdx.x + blockIdx.x * blockDim.x;
	
	cases[0]=1;cases[1]=1;cases[2]=1;cases[3]=1;cases[4]=1;cases[5]=1;cases[6]=1;cases[7]=1;cases[8]=1;
        controls[0]=1;controls[1]=1;controls[2]=1;controls[3]=1;controls[4]=1;controls[5]=1;controls[6]=1;controls[7]=1;controls[8]=1;
        
	if ((tid < jobs) && (tid > LD_width )) {

                for ( m = 0 ; m < cRows ; m++ ) {

                                x = snpdata[m * cols + ref];
                                y = snpdata[m * cols + (ref + tid)];

                                if ( x == '0' && y == '0') { cases[0]++; }
                                else if (x == '0' && y == '1') { cases[1]++; }
                                else if (x == '0' && y == '2') { cases[2]++; }
                                else if (x == '1' && y == '0') {  cases[3]++; }
                                else if (x == '1' && y == '1') {  cases[4]++; }
                                else if (x == '1' && y == '2' ) { cases[5]++; }
                                else if (x == '2' && y == '0' ) { cases[6]++;}
                                else if (x == '2' && y == '1') { cases[7]++; }
                                else if (x == '2' && y == '2') { cases[8]++; }
                                else { //do nothing
                               }

                        }
               
		 for ( n = cRows ; n < cRows + contRows ; n++ ) {
                              x = snpdata[n * cols + ref];
                              y = snpdata[n * cols + (ref + tid)];

                                if ( x == '0' && y == '0' ) { controls[0]++; }
                                else if (x == '0' && y == '1') { controls[1]++; }
                                else if (x == '0' && y == '2') { controls[2]++; }
                                else if (x == '1' && y == '0') { controls[3]++; }
                                else if (x == '1' && y == '1') { controls[4]++; }
                                else if (x == '1' && y == '2' ) { controls[5]++; }
                                else if (x == '2' && y == '0' ) { controls[6]++;}
                                else if (x == '2' && y == '1') { controls[7]++; }
                                else if (x == '2' && y == '2') { controls[8]++; }
                                else { //do nothing
                               }

                               }
				
				tot_cases = cases[0]+cases[1]+cases[2]+cases[3]+cases[4]+cases[5]+cases[6]+cases[7]+cases[8];
                                tot_controls = controls[0]+controls[1]+controls[2]+controls[3]+controls[4]+controls[5]+controls[6]+controls[7]+controls[8];
                                total = tot_cases + tot_controls;

				for( p = 0 ; p < 9; p++) {
                                                exp[p] = (float)cases[p] + controls[p]; 
                                                Cexpected[p] = tot_cases * exp[p] / total;
                                                Conexpected[p] = tot_controls * exp[p] / total;
						numerator1 = (float)cases[p] - Cexpected[p];
						numerator2 = (float)controls[p] - Conexpected[p];
						chisquare += numerator1 * numerator1 / Cexpected[p] +  numerator2 * numerator2 / Conexpected[p];
						//cuPrintf("chisquare %d is numerator1 %f numerator 2 %f =  %f\n",p,numerator1,numerator2,chisquare);
						
				}


				dev_colid[tid] = tid;
 				results[tid] = chisquare;
				
		}
}

